#ifndef KEY_VOLUME_MANAGER_MESSAGES_H
#define KEY_VOLUME_MANAGER_MESSAGES_H

#ifndef TOSH_DATA_LENGTH
#define TOSH_DATA_LENGTH 100
#elif
#warning TOSH_DATA_LENGTH already set when processing KeyVolumeManagerMessages  
#endif

#include "message.h"

enum {
  AM_KEY_VOLUME_MANAGER = 0x55,
};  

/**
 * This message is used only to automatically generate java class with MIG
 * associated with AM type AM_KEY_VOLUME_MANAGER.
 * Message classes for message types SerialReqPacket and SerialReplyPacket extends
 * this class.
 */
typedef nx_struct key_volume_manager {	
}key_volume_manager;


  enum {
    KVM_CMD_WRITE       = 0,
    KVM_CMD_READ        = 1,
    KVM_CMD_SYNC        = 2,
    
    KVM_DATA_LEN        = TOSH_DATA_LENGTH - 5, //
    
    AM_SERIALREQPACKET  = AM_KEY_VOLUME_MANAGER,
    AM_SERIALREPLYPACKET= AM_KEY_VOLUME_MANAGER,
  };

  typedef nx_struct SerialReqPacket {
    nx_uint8_t cmd;
    nx_uint16_t offset;
    nx_uint16_t len;
    nx_uint8_t data[KVM_DATA_LEN];
  } SerialReqPacket;
  
  typedef nx_struct SerialReplyPacket {
    nx_uint8_t error;
    nx_uint8_t data[KVM_DATA_LEN];
  } SerialReplyPacket;





#endif /* KEY_VOLUME_MANAGER_MESSAGES_H */
