/******************************************************************************
 * Author: Patrick E. Lanigan
 * Description: Type data for nesC port of SHA-1 reference code from RFC 3174.   
 *****************************************************************************/

#ifndef _SHA1_H_
#define _SHA1_H_

#define SHA1HashSize 20

/*
 *  This structure will hold context information for the SHA-1
 *  hashing operation
 */
typedef struct SHA1Context {
	uint32_t Intermediate_Hash[SHA1HashSize/4]; /* Message Digest */

	uint32_t Length_Low;				/* Message length in bits */
	uint32_t Length_High;				/* Message length in bits */

	uint32_t Message_Block_Index;		/* Index into message block array */
	uint8_t Message_Block[64];			/* 512-bit message blocks */

	int Computed;						/* Is the digest computed? */
	int Corrupted;						/* Is the message digest corrupted? */
} SHA1Context;

#endif
