/* Copyright (c) 2009 The Regents of the Signet Group.
*  All rights reserved.
*
*  Permission to use, copy, modify, and distribute this software and its
*  documentation for any purpose, without fee, and without written
*  agreement is hereby granted, provided that the above copyright
*  notice, the (updated) modification history and the author appear in
*  all copies of this source code.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS `AS IS'
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS
*  BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
*  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, LOSS OF USE, DATA,
*  OR PROFITS) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
*  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
*  THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef PARTITION_STORAGE_H
#define PARTITION_STORAGE_H

// Flags
enum{
	SPE_USED     =(1<<0),
	SPE_PROG     =(1<<1),
	SPE_NV_MEM   =(1<<2),
	SPE_WORKING  =(1<<3),
		
	S_PARTITION_ENTRY_SIZE	=16,// sizeof(SignetPartitionEntry_struct)
	MAX_PARTITION_ENTRY 	=16,// EF_SIZE_PAGE/S_PARTITION_ENTRY_SIZE
	PARTITION_TABLE_SIZE	=S_PARTITION_ENTRY_SIZE*MAX_PARTITION_ENTRY,
	EF_PARTITION_TABLE_ADDR =0x00
};


typedef struct SignetPartitionEntry_struct {
    uint16_t flags;
    uint16_t hashName;
    uint32_t startAddr; 			// first byte written
    uint32_t size;      			// partition size
    uint16_t progStartOffs; 		// offset from beginning of partition to first code instruction
    uint16_t keep_align;			// just to keep alignment to 32bit, recycle this field space when needed.
} SignetPartitionEntry;

typedef SignetPartitionEntry SynapsePartitionEntry;

uint8_t partitionUsed(SignetPartitionEntry *pe){
	return (~(pe->flags) & SPE_USED);
}


#endif /* PARTITION_STORAGE_H */
