/* Copyright (c) 2009 The Regents of the Signet Group.
*  All rights reserved.
*
*  Permission to use, copy, modify, and distribute this software and its
*  documentation for any purpose, without fee, and without written
*  agreement is hereby granted, provided that the above copyright
*  notice, the (updated) modification history and the author appear in
*  all copies of this source code.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS `AS IS'
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS
*  BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
*  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, LOSS OF USE, DATA,
*  OR PROFITS) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
*  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
*  THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef STATS_COLLECTOR_H
#define STATS_COLLECTOR_H

#define UQ_STATS_COLLECTOR_8 "UQ_STATS_COLLECTOR_8"
#define UQ_STATS_COLLECTOR_16 "UQ_STATS_COLLECTOR_16"
#define UQ_STATS_COLLECTOR_32 "UQ_STATS_COLLECTOR_32"

#define DEFINE_STAT8(name)  enum{STAT8_  ## name=unique(UQ_STATS_COLLECTOR_8)};
#define DEFINE_STAT16(name) enum{STAT16_ ## name=unique(UQ_STATS_COLLECTOR_16)};
#define DEFINE_STAT32(name) enum{STAT32_ ## name=unique(UQ_STATS_COLLECTOR_32)};

enum{
	STATS_MESSAGE_BUFFER_SIZE=
	     sizeof(nx_uint32_t) + 
	   2*sizeof(nx_uint16_t) + 
	   4*sizeof(nx_uint8_t)
	,
};

#ifndef AM_STAT_COLLECTOR_MESSAGE_DEF
#define AM_STAT_COLLECTOR_MESSAGE_DEF 88
#endif

enum{
	AM_STAT_COLLECTOR_MESSAGE=AM_STAT_COLLECTOR_MESSAGE_DEF,
	AM_STATCOLLECTORMESSAGE=AM_STAT_COLLECTOR_MESSAGE,// Only for MIG
};

typedef nx_struct StatCollectorMessage{
	nx_uint8_t stats8;
	nx_uint8_t stats16;
	nx_uint8_t stats32;
	nx_uint8_t buffer[STATS_MESSAGE_BUFFER_SIZE];
}StatCollectorMessage;

#endif /* STATS_COLLECTOR_H */
