/* Copyright (c) 2009 The Regents of the Signet Group.
*  All rights reserved.
*
*  Permission to use, copy, modify, and distribute this software and its
*  documentation for any purpose, without fee, and without written
*  agreement is hereby granted, provided that the above copyright
*  notice, the (updated) modification history and the author appear in
*  all copies of this source code.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS `AS IS'
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS
*  BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
*  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, LOSS OF USE, DATA,
*  OR PROFITS) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
*  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
*  THE POSSIBILITY OF SUCH DAMAGE.
*/

#include "ext_leds.h"
#include "asm_utils.h"

void int2leds4(uint16_t n)
{
    uint16_t i;
    P5OUT &= 0xF0;
    P5OUT |= (n & 0x000F);
    for(i=0; i<1000; i++) {
        waitMicro(1000);
    }
}

void int2leds8(uint8_t n)
{
	uint8_t i;
	for(i=0; i<8 ; i++){ //SR - 1st reading
	flash((n>>i & 1)+1);
	flash((n>>i & 1)+1);
	flash(0);
	flash(0);
    }
}
void int2leds16(uint16_t n)
{
	int2leds8((uint8_t)(n & 0xFF));
	flash(7);
	flash(7);
	int2leds8((uint8_t)(n>>8 & 0xFF));
}
void int2leds32(uint32_t n)
{
    int2leds16(n&0xFFFF);
    int2leds16((n>>16)&0xFFFF);
}

void blink(uint8_t l)
{
    uint8_t i;
    P5OUT |= 0xF1;
    for(i=0; i<5; i++) {
        uint16_t j, k;
        P5OUT ^= l<<4;
        for(k=0x05; k>0; k--)
            for(j=0xFFFF; j>0; j--);
    }
	P5OUT |= 0xF1;
}

void flash(uint8_t l)
{
	l &=0x0F;
    P5OUT |= 0xF1;
    P5OUT ^= l<<4;
    uint16_t j, k;
        for(k=0x05; k>0; k--)
            for(j=0xFFFF; j>0; j--);
	P5OUT |= 0xF1;
}

void blink13() //101
{
	blink(5);
}
void blink12() //110
{
blink(3);
}
void blink123() //111
{
	blink(7);
}
